<template>
  <div class="createPost-container">
    <div>
      <b-form ref="postForm" :model="postForm" :rules="rules">
        <h3>اطلاعات آدرس</h3>
        <hr>
        <b-form-group :label="$t('form.province')" label-for="province">
          <b-form-input id="province" v-model="postForm.province" type="text" :placeholder="$t('form.province')" required />
        </b-form-group>

        <b-form-group :label="$t('form.city')" label-for="city">
          <b-form-input id="city" v-model="postForm.city" type="text" :placeholder="$t('form.city')" required />
        </b-form-group>

        <b-form-group :label="$t('form.address')" label-for="address">
          <b-form-input id="address" v-model="postForm.address" type="text" :placeholder="$t('form.address')" required />
        </b-form-group>

        <b-form-group :label="$t('form.region')" label-for="region">
          <b-form-input id="address" v-model="postForm.region" type="text" :placeholder="$t('form.region')" required />
        </b-form-group>

        <b-form-group :label="$t('form.subscriptionNumber')" label-for="subscriptionNumber">
          <b-form-input id="subscriptionNumber" v-model="postForm.subscriptionNumber" type="text" :placeholder="$t('form.subscriptionNumber')" required />
        </b-form-group>

        <b-form-group :label="$t('form.geoPlace')" label-for="geoPlace">
          <b-form-input id="geoPlace" v-model="postForm.geoPlace" type="text" :placeholder="$t('form.geoPlace')" required />
        </b-form-group>

        <b-form-group :label="$t('form.counterType')" label-for="counterType">
          <b-form-select v-model="postForm.counterType" :options="options">&nbsp;</b-form-select>
        </b-form-group>

        <h3>اطلاعات بانی</h3>
        <hr>
        <b-form-group :label="$t('form.name')" label-for="province">
          <b-form-input id="province" v-model="postForm.name" type="text" :placeholder="$t('form.name')" required />
        </b-form-group>

        <b-form-group :label="$t('user.family')" label-for="city">
          <b-form-input id="city" v-model="postForm.family" type="text" :placeholder="$t('user.family')" required />
        </b-form-group>

        <b-form-group :label="$t('user.nationalcode')" label-for="address">
          <b-form-input id="address" v-model="postForm.nationalcode" type="text" :placeholder="$t('user.nationalcode')" required />
        </b-form-group>

        <b-form-group :label="$t('form.accountId')" label-for="region">
          <b-form-input id="address" v-model="postForm.accountId" type="text" :placeholder="$t('form.accountId')" required />
        </b-form-group>

        <b-form-group :label="$t('form.valueContour')" label-for="subscriptionNumber">
          <b-form-input id="subscriptionNumber" v-model="postForm.valueContour" type="text" :placeholder="$t('form.valueContour')" required />
        </b-form-group>

        <b-form-group :label="$t('form.accountNumber')" label-for="geoPlace">
          <b-form-input id="geoPlace" v-model="postForm.accountNumber" type="text" :placeholder="$t('form.accountNumber')" required />
        </b-form-group>

        <b-button type="submit" variant="primary" @click.prevent.stop="submitForm">{{ $t('form.submit') }}</b-button>
        <b-button type="reset" variant="danger" @click.prevent.stop="onCancel">{{ $t('form.cancel') }}</b-button>
      </b-form>
    </div>
  </div>
</template>

<script>
import Address from '@/api/address';

const addressApi = new Address('address');
const defaultForm = {
  address: '',
  subscriptionNumber: '',
  geoPlace: '',
  id: undefined,
};

export default {
  name: 'AddressDetail',

  components: {},
  props: {
    isEdit: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    const validateRequire = (rule, value, callback) => {
      if (value === '') {
        this.$message({
          message: rule.field + ' is required',
          type: 'error',
        });
        callback(new Error(rule.field + ' is required'));
      } else {
        callback();
      }
    };
    return {
      postForm: {
        address: '',
        subscriptionNumber: '',
        geoPlace: '',
      },
      loading: false,
      userListOptions: [],
      rules: {
        address: [{ validator: validateRequire }],
        subscriptionNumber: [{ validator: validateRequire }],
      },
      options: [
        { value: 'new', text: this.$i18n.t(`form.newCounter`) },
        { value: 'old', text: this.$i18n.t(`form.oldCounter`) },
      ],
      tempRoute: {},
    };
  },
  computed: {
    contentShortLength() {
      return this.postForm.content_short.length;
    },
    lang() {
      return this.$store.getters.language;
    },
  },
  created() {
    if (this.isEdit) {
      const id = this.$route.params && this.$route.params.id;
      this.fetchData(id);
    } else {
      this.postForm = Object.assign({}, defaultForm);
    }

    // Why need to make a copy of this.$route here?
    // Because if you enter this page and quickly switch tag, may be in the execution of the setTagsViewTitle function, this.$route is no longer pointing to the current page
    this.tempRoute = Object.assign({}, this.$route);
  },
  methods: {
    onSubmit() {
      this.$message('submit!');
    },
    onCancel() {
      this.$message({
        message: 'cancel!',
        type: 'warning',
      });
    },
    fetchData(id) {
      addressApi(id)
        .then(response => {
          this.postForm = response.data;
          // Just for test
          this.postForm.title += `   Article Id:${this.postForm.id}`;
          this.postForm.content_short += `   Article Id:${this.postForm.id}`;
        })
        .catch(err => {
          console.log(err);
        });
    },
    submitForm() {
      this.loading = true;
      addressApi
        .store(this.postForm)
        .then(response => {
          this.$message({
            message: 'New Address ' + this.postForm.title + 'has been created successfully.',
            type: 'success',
            duration: 5 * 1000,
          });
        })
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          this.userCreating = false;
        });
    },
  },
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
@import "~@/styles/mixin.scss";
.createPost-container {
  position: relative;
  .createPost-main-container {
    padding: 0 45px 20px 50px;
    .postInfo-container {
      position: relative;
      @include clearfix;
      margin-bottom: 10px;
      .postInfo-container-item {
        float: left;
      }
    }
  }
  .word-counter {
    width: 40px;
    position: absolute;
    right: -10px;
    top: 0px;
  }
}
</style>
<style>
.createPost-container label.el-form-item__label {
  text-align: left;
}
</style>
